app1/urls.py
from django.urls import path
from .views import matkul_list, matkul_create, home, matkul_json

urlpatterns = [
    path('', home, name='schedule'),
    path('matkul-list/', matkul_list, name='list-matkul'),
    path('create-matkul/', matkul_create, name='create-matkul'),
    path('json/', matkul_json, name='json'),
    
]

covid_data/urls.py
from django.urls import path
from .views import covid_data, search, searchF, getModelsF

urlpatterns = [
    path('', covid_data, name='covid_data'),
    path('data/', search, name='search'),
    path('data/json', searchF, name='searchF'),
    path('getmodels', getModelsF, name='getModelsF'),
]

midtermprojectPBP_F03/urls.py
from os import stat
from django.contrib import admin
from django.urls import include, path
from django.conf import settings
from django.conf.urls.static import static

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('main.urls')),
    path('to-do-list/', include('to_do_list.urls')),
    path('info-pendidikan/', include('info_pendidikan.urls')),
    path('EventApp/', include('app7_EventApp.urls')),
    path('covid-data/', include('covid_data.urls')),
    path('add-forum/', include('forum.urls')),
    path('susun-jadwal-matkul/', include('app1.urls')),
    path('quiz-of-pandemic/', include('quizes.urls'))
]

urlpatterns += static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)

covid_data/models.py
from django.db import models
from django.contrib.auth import get_user_model
from django.conf import settings
# Create your models here.

class SearchedCovidData(models.Model):
    author = models.ForeignKey(settings.AUTH_USER_MODEL,
        null=True, blank=True, on_delete=models.SET_NULL)
    provinsi = models.CharField(max_length=30)
    kasus_positif = models.CharField(max_length=10)
    kasus_sembuh = models.CharField(max_length=10)
    kasus_meninggal = models.CharField(max_length=10)

covid_data/forms.py
from django import forms
PROVINSI_LIST= [
    ('DKI JAKARTA', 'DKI JAKARTA'),
    ('JAWA BARAT', 'JAWA BARAT'),
    ('JAWA TENGAH', 'JAWA TENGAH'),
    ('JAWA TIMUR', 'JAWA TIMUR'),
    ('KALIMANTAN TIMUR', 'KALIMANTAN TIMUR'),
    ('DAERAH ISTIMEWA YOGYAKARTA', 'DAERAH ISTIMEWA YOGYAKARTA'),
    ('BANTEN', 'BANTEN'),
    ('RIAU', 'RIAU'),
    ('BALI', 'BALI'),
    ('SULAWESI SELATAN', 'SULAWESI SELATAN'),
    ('SUMATERA UTARA', 'SUMATERA UTARA'),
    ('SUMATERA BARAT', 'SUMATERA BARAT'),
    ('KALIMANTAN SELATAN', 'KALIMANTAN SELATAN'),
    ('NUSA TENGGARA TIMUR', 'NUSA TENGGARA TIMUR'),
    ('SUMATERA SELATAN', 'SUMATERA SELATAN'),
    ('KEPULAUAN RIAU', 'KEPULAUAN RIAU'),
    ('KEPULAUAN BANGKA BELITUNG', 'KEPULAUAN BANGKA BELITUNG'),
    ('LAMPUNG', 'LAMPUNG'),
    ('SULAWESI TENGAH', 'SULAWESI TENGAH'),
    ('KALIMANTAN TENGAH', 'KALIMANTAN TENGAH'),
    ('KALIMANTAN BARAT', 'KALIMANTAN BARAT'),
    ('ACEH', 'ACEH'),
    ('KALIMANTAN UTARA', 'KALIMANTAN UTARA'),
    ('SULAWESI UTARA', 'SULAWESI UTARA'),
    ('PAPUA', 'PAPUA'),
    ('JAMBI', 'JAMBI'),
    ('NUSA TENGGARA BARAT', 'NUSA TENGGARA BARAT'),
    ('PAPUA BARAT', 'PAPUA BARAT'),
    ('BENGKULU', 'BENGKULU'),
    ('SULAWESI TENGGARA', 'SULAWESI TENGGARA'),
    ('MALUKU', 'MALUKU'),
    ('SULAWESI BARAT', 'SULAWESI BARAT'),
    ('MALUKU UTARA', 'MALUKU UTARA'),
    ('GORONTALO', 'GORONTALO'),
    ]

class SearchForm(forms.Form):
    provinsi = forms.CharField(label='Pilih Provinsi', widget=forms.Select(choices=PROVINSI_LIST))

covid_data/views.py
from django.shortcuts import render
from django.http import JsonResponse
from django.contrib.auth.models import User
from django.template import loader
from .forms import SearchForm
import requests
from .models import SearchedCovidData
from django.views.decorators.csrf import csrf_exempt
from django.forms import model_to_dict
from django.core.serializers.json import DjangoJSONEncoder
from django.db.models import Model
from django.core import serializers
import json
class ExtendedEncoder(DjangoJSONEncoder):

    def default(self, o):

        if isinstance(o, Model):
            return model_to_dict(o)

        return super().default(o)

def covid_data(request):
    searched_data = SearchedCovidData.objects.all().order_by('-id')
    form = SearchForm(request.POST or None)
    response = requests.get('https://data.covid19.go.id/public/api/prov_list.json')
    try:
        data = response.json()
    except:
        data = None
    kasus = []
    error = None
    if data is not None:
        for o in data['list_data']:
            datanya = {}
            datanya['provinsi'] = o['key']
            datanya['kasus_positif'] = o['status']['buckets'][2]['doc_count']
            datanya['kasus_sembuh'] = o['status']['buckets'][0]['doc_count']
            datanya['kasus_meninggal'] = o['status']['buckets'][1]['doc_count']
            kasus.append(datanya)
    else:
        error = "Maaf sumber data yang kami pakai sedang bermasalah"
    return render(request, 'covid_data.html', {
        'searched_data': searched_data,
        'form': form,
        'error': error,
        'date':data['last_date'],
        })

@csrf_exempt
def search(request):
    # request should be ajax and method should be GET.
    if request.is_ajax and request.method == "GET":
        search_key = request.GET.get('search')
        response = requests.get('https://data.covid19.go.id/public/api/prov_list.json')
        data = response.json()
        kasus = []
        for o in data['list_data']:
            datanya = {}
            datanya['provinsi'] = o['key']
            datanya['kasus_positif'] = o['status']['buckets'][2]['doc_count']
            datanya['kasus_sembuh'] = o['status']['buckets'][0]['doc_count']
            datanya['kasus_meninggal'] = o['status']['buckets'][1]['doc_count']
            if request.user.is_authenticated:
                if datanya['provinsi'] in search_key:
                    new = SearchedCovidData(author = request.user,provinsi=datanya['provinsi'], kasus_positif=datanya['kasus_positif'],kasus_sembuh=datanya['kasus_sembuh'],kasus_meninggal=datanya['kasus_meninggal'])
                    new.save()
            kasus.append(datanya)
        
        data_html = loader.render_to_string(
            'data.html',
            {'data': kasus, 'search_key': search_key, 'date':data['last_date'],}
        )
        output_data = {
            'data_html': data_html,
        }
        return JsonResponse(output_data, status=200)
    # some error occured
    return JsonResponse({"error": ""}, status=400)

def searchF(request):
    # request should be ajax and method should be GET.
    if request.method == "GET":
        search_key = request.GET.get('search')
        curr_user_id = request.GET.get('user_id')
        response = requests.get('https://data.covid19.go.id/public/api/prov_list.json')
        data = response.json()
        searchedData = {}
        for o in data['list_data']:
            if o['key'] in search_key:
                searchedData['provinsi'] = o['key']
                searchedData['kasus_positif'] = o['status']['buckets'][2]['doc_count']
                searchedData['kasus_sembuh'] = o['status']['buckets'][0]['doc_count']
                searchedData['kasus_meninggal'] = o['status']['buckets'][1]['doc_count']
                if curr_user_id != "":
                    new = SearchedCovidData(author = User.objects.get(pk = curr_user_id),provinsi=searchedData['provinsi'], kasus_positif=searchedData['kasus_positif'],kasus_sembuh=searchedData['kasus_sembuh'],kasus_meninggal=searchedData['kasus_meninggal'])
                    new.save()
                return JsonResponse({'searchedData':searchedData}, status=200)
    # some error occured
    return JsonResponse({"error": ""}, status=400)

def getModelsF(request):
    if request.method == "GET":
        curr_user_id = int(request.GET.get('user_id'))
        searchedData = SearchedCovidData.objects.filter(author = User.objects.get(pk = curr_user_id)).order_by('-id')
        tmpJson = serializers.serialize("json",searchedData)
        tmpObj = json.loads(tmpJson)
        return JsonResponse({"searchedData": tmpObj},encoder=ExtendedEncoder, status=200)
    # some error occured
    return JsonResponse({"error": ""}, status=400)

covid_data/templates/covid_data.html
{% extends 'base.html' %}
{% load static %}

{% block meta %}
<title>Menampilkan Sebaran Data Covid-19 menggunakan Django Dan API Kawal Corona</title>
<script type="text/javascript" src="https://code.jquery.com/jquery-3.3.1.js"></script>	
<script src="https://code.jquery.com/jquery-3.4.1.slim.min.js" integrity="sha384-J6qa4849blE2+poT4WnyKhv5vZF5SrPo0iEjwBvKU7imGFAV0wwj1yYfoRSJoZ+n" crossorigin="anonymous"></script>
<script src="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/js/bootstrap.min.js" integrity="sha384-wfSDF2E50Y2D1uUdj0O3uMBJnjuUD4Ih7YwaYd1iqfktj0Uod8GCExl3Og8ifwB6" crossorigin="anonymous"></script>
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>    
<link rel="stylesheet" type="text/css" href="https://cdn.datatables.net/1.10.20/css/dataTables.bootstrap4.min.css">
<link rel="stylesheet" href="{% static 'css/covid_data/covid_data.css' %}">
{% endblock meta %}

{% block content %}
<h1 class="page-title">Data Sebaran Covid-19 di Indonesia</h1><br>
<h4 class="page-title">Data provided by data.covid19.go.id API</h4>
<h6 class="page-title">last updated : {{date}}</h6>
<br/>
<br/>
<div class="container" id="data-table">
    
</div>

<div class="fluid-container" id="initial-visible">
{% if not error %}
    <form method="POST" id="search-form">
        {% csrf_token %}
        {{form}}<br>
        <input class="btn btn-outline-success" type="submit" value="Search" id="search-button">
    </form>
    {% if user.is_authenticated %}
    <div class="fluid-container">
        <h1 class="page-title">Recently Searched</h1>
        <table id="example" class="table table-striped table-bordered" style="width:100%">
            <thead>
                <tr>			
                    <th>Provinsi</th>
                    <th>Dalam Perawatan</th>
                    <th>Kasus Sembuh</th>
                    <th>Kasus Meninggal</th>
                </tr>
            </thead>
            <tbody>
                {% for data in searched_data %}
                {% if user.id == data.author_id %}     
                <tr>				
                    <td>{{data.provinsi}}</td>
                    <td>{{data.kasus_positif}}</td>
                    <td>{{data.kasus_sembuh}}</td>
                    <td>{{data.kasus_meninggal}}</td>
                </tr>
                {% endif %}
                {% endfor %}
            </tbody>
        </table>
        </div>
    {% endif %}
{% else %}
    <h1>{{error}}</h1>
{% endif %}
</div>

<script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.0/dist/umd/popper.min.js" integrity="sha384-Q6E9RHvbIyZFJoft+2mJbHaEWldlvI9IOYy5n3zV9zzTtmI3UksdQRVvoxMfooAo" crossorigin="anonymous"></script>
<script>
     $(document).ready(function() {
        $("#id_provinsi").prepend('<option value="" disabled selected hidden>Pilih Provinsi...</option>')
        $("#search-button").click(function(e){
            e.preventDefault();
            $("#initial-visible").fadeOut();
            var search_key = $("#id_provinsi").find(":selected").val();
            $.ajax({
                url: "{% url 'search' %}",
                method: 'GET',
                data : {'search':search_key},
                success: function(data){
                    console.log("success");
                    $('#data-table').append(
                       data['data_html']
                    )
                },
                error: function(error_data){
                    console.log("error")
                    console.log(error_data)
                }
            })
        });
       
    } );
</script>
{% endblock content %}

covid_data/templates/data.html
    <table id="example" class="table table-striped table-bordered" style="width:100%">
        <thead>
            <tr>			
                <th>Provinsi</th>
                <th>Dalam Perawatan</th>
                <th>Kasus Sembuh</th>
                <th>Kasus Meninggal</th>
            </tr>
        </thead>
        <tbody>
            {% for covid in data %}
            {% if covid.provinsi in search_key %}    
            <tr>				
                <td>{{covid.provinsi}}</td>
                <td>{{covid.kasus_positif}}</td>
                <td>{{covid.kasus_sembuh}}</td>
                <td>{{covid.kasus_meninggal}}</td>
            </tr>
            {% endif %}
            {% endfor %}
        </tbody>
    </table>
    <button type ="button" class="btn btn-outline-info" id="back-button">Back</button>
<script>
    $("#back-button").click(function(e){
        location.reload();
    });
</script>